# LibRec
[LibRec](http://www.librec.net) is an advanced Java open source library of recommender systems with around 70 multiple recommendation algorithms, which can effectively solve the rating and ranking problems. Recommender system is a typical application of Machine Learning and Big Data, which is used to provide personalized recommendations. As an implementation of recommendation algorithms, LibRec improves a lot in modularization, implementation, and availability. In addition, the recommendation performance is further enhanced.

## [Introduction](http://wiki.librec.net/doku.php?id=introduction)
+ Overview
- Features
- Getting started
    - Clone source code from github
    - Run a recommender in console
    - Run a recommender in IDE
    - What happened
- Need Help?

## [CLI Walkthrough](http://wiki.librec.net/doku.php?id=CLIWalkthrough)
  + Usage
  + Running
  + Configuration file

## Build-in dataset
  + [Data File Format](http://wiki.librec.net/doku.php?id=DataFileFormat)
     - Text
     - Arff
  + [FilmTrust](http://wiki.librec.net/doku.php?id=FilmTrust)


## Modules
+ [Data Model](http://wiki.librec.net/doku.php?id=DataModel)
  - Convertor
  - Splitter
  - Appender
+ [Recommender](http://wiki.librec.net/doku.php?id=Recommender)
    - Similarity
    - Algorithms
    - Development
+ [Evaluator](http://wiki.librec.net/doku.php?id=Evaluator)
+ [Filter](http://wiki.librec.net/doku.php?id=Filter)


## Appendix
+ [Algorithm List](http://wiki.librec.net/doku.php?id=AlgorithmList)
+ [Configuration List](http://wiki.librec.net/doku.php?id=ConfigurationList)
+ [API Documents](http://librec.net/doc/librec-v2.0/)

## Blogs
+ [LibRec通识篇](http://mp.weixin.qq.com/s/AB39ihVWXYHRbeODbGO-2g)
+ [LibRec工程导入](http://mp.weixin.qq.com/s/OyYn5_4GYAbF0L0SFgsHVQ)
+ [LibRec命令行操作](http://mp.weixin.qq.com/s/xnkg6BGyUUKmbs009p8XCw)
+ [LibRec团队一年记](http://mp.weixin.qq.com/s/vDnca1FMW9vVrFDgti_1IA)
+ [LibRec工作进展[2017.2.16]](http://mp.weixin.qq.com/s/WJP32VSChT4y_ofIBhbZ4A)
+ LibRec每周算法
  + [CDL (KDD'15)](https://mp.weixin.qq.com/s/AqgxnfR4h1FBRmmEe6uPqQ)
  + [CDAE (WSDM'16)](https://mp.weixin.qq.com/s/qwDIvXlpP5UIBTwtpqhYsg)
  + [FISM (KDD'13)](https://mp.weixin.qq.com/s/gHKOArFzUM9Zn8hEsA-1wQ)
  + [HFT (RecSys'13)](https://mp.weixin.qq.com/s/7yjA3_oCI5nSH4tv04BIhQ)

